const beforeUnloadHandler = (event) => {
  event.preventDefault();
};

const forms = document.querySelectorAll("form");

for (let form of forms) {
  let inputs = form.querySelectorAll("input");
  for (input of inputs) {
    input.addEventListener("input", (event) => {
      window.addEventListener("beforeunload", beforeUnloadHandler);
    });
  }

  form.addEventListener("submit", (event) => {
    window.removeEventListener("beforeunload", beforeUnloadHandler);
  });
  form.addEventListener("reset", (event) => {
    window.removeEventListener("beforeunload", beforeUnloadHandler);
  });

  let categorySelect = form.querySelector(".category-select");
  if (categorySelect) {
    let input = categorySelect.querySelector("select");
    let icon = categorySelect.querySelector("span");
    let icons = JSON.parse(input.dataset.icons);

    icon.className = `ri-${icons[input.value] || "folder"}-line`;
    input.addEventListener("input", (event) => {
      icon.className = `ri-${icons[input.value] || "folder"}-line`;
    });
  }
}
